From 220e5b5e7e4024404989a526bcde6a0e786180fc Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sat, 16 Nov 2024 04:08:45 +0200
Subject: [PATCH 85/85] Bump tilespec capstr

See RM #1126

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 client/tilespec.c        | 2 +-
 data/3d.tilespec         | 2 +-
 data/alio.tilespec       | 2 +-
 data/amplio.tilespec     | 2 +-
 data/amplio2.tilespec    | 2 +-
 data/cimpletoon.tilespec | 2 +-
 data/hex2t.tilespec      | 2 +-
 data/hexemplio.tilespec  | 2 +-
 data/isophex.tilespec    | 2 +-
 data/isotrident.tilespec | 2 +-
 data/toonhex.tilespec    | 2 +-
 data/trident.tilespec    | 2 +-
 12 files changed, 12 insertions(+), 12 deletions(-)

diff --git a/client/tilespec.c b/client/tilespec.c
index bf6523abfc..56c4285ce9 100644
--- a/client/tilespec.c
+++ b/client/tilespec.c
@@ -79,7 +79,7 @@
 
 #include "tilespec.h"
 
-#define TILESPEC_CAPSTR "+Freeciv-tilespec-3.2-Devel-2022-Jun-21 duplicates_ok"
+#define TILESPEC_CAPSTR "+Freeciv-tilespec-3.3-Devel-2024-Nov-16 duplicates_ok"
 /*
  * Tilespec capabilities acceptable to this program:
  *
diff --git a/data/3d.tilespec b/data/3d.tilespec
index 5566540439..e6406c1914 100644
--- a/data/3d.tilespec
+++ b/data/3d.tilespec
@@ -1,7 +1,7 @@
 [tilespec]
 
 ; Format and options of this tilespec file:
-options = "+Freeciv-tilespec-3.2-Devel-2022-Jun-21"
+options = "+Freeciv-tilespec-3.3-Devel-2024-Nov-16"
 
 ; A simple name for the tileset specified by this file:
 name = "Trident"
diff --git a/data/alio.tilespec b/data/alio.tilespec
index 0847e9a804..fc1266ca4d 100644
--- a/data/alio.tilespec
+++ b/data/alio.tilespec
@@ -2,7 +2,7 @@
 [tilespec]
 
 ; Format and options of this tilespec file:
-options = "+Freeciv-tilespec-3.2-Devel-2022-Jun-21"
+options = "+Freeciv-tilespec-3.3-Devel-2024-Nov-16"
 
 ; A simple name for the tileset specified by this file:
 name = "Alio"
diff --git a/data/amplio.tilespec b/data/amplio.tilespec
index 64b889f45e..43f96156c2 100644
--- a/data/amplio.tilespec
+++ b/data/amplio.tilespec
@@ -2,7 +2,7 @@
 [tilespec]
 
 ; Format and options of this tilespec file:
-options = "+Freeciv-tilespec-3.2-Devel-2022-Jun-21"
+options = "+Freeciv-tilespec-3.3-Devel-2024-Nov-16"
 
 ; A simple name for the tileset specified by this file:
 name = "Amplio"
diff --git a/data/amplio2.tilespec b/data/amplio2.tilespec
index 8f3dbb7cc0..29077b5545 100644
--- a/data/amplio2.tilespec
+++ b/data/amplio2.tilespec
@@ -2,7 +2,7 @@
 [tilespec]
 
 ; Format and options of this tilespec file:
-options = "+Freeciv-tilespec-3.2-Devel-2022-Jun-21"
+options = "+Freeciv-tilespec-3.3-Devel-2024-Nov-16"
 
 ; A simple name for the tileset specified by this file:
 name = "Amplio2"
diff --git a/data/cimpletoon.tilespec b/data/cimpletoon.tilespec
index d96a693514..b8437a4535 100644
--- a/data/cimpletoon.tilespec
+++ b/data/cimpletoon.tilespec
@@ -2,7 +2,7 @@
 [tilespec]
 
 ; Format and options of this tilespec file:
-options = "+Freeciv-tilespec-3.2-Devel-2022-Jun-21"
+options = "+Freeciv-tilespec-3.3-Devel-2024-Nov-16"
 
 ; A simple name for the tileset specified by this file:
 name = "Cimpletoon"
diff --git a/data/hex2t.tilespec b/data/hex2t.tilespec
index b1d3f99739..dcb39b8984 100644
--- a/data/hex2t.tilespec
+++ b/data/hex2t.tilespec
@@ -2,7 +2,7 @@
 [tilespec]
 
 ; Format and options of this tilespec file:
-options = "+Freeciv-tilespec-3.2-Devel-2022-Jun-21"
+options = "+Freeciv-tilespec-3.3-Devel-2024-Nov-16"
 
 ; A simple name for the tileset specified by this file:
 name = "Hex-2"
diff --git a/data/hexemplio.tilespec b/data/hexemplio.tilespec
index 3e5667b7c4..211606042c 100644
--- a/data/hexemplio.tilespec
+++ b/data/hexemplio.tilespec
@@ -2,7 +2,7 @@
 [tilespec]
 
 ; Format and options of this tilespec file:
-options = "+Freeciv-tilespec-3.2-Devel-2022-Jun-21"
+options = "+Freeciv-tilespec-3.3-Devel-2024-Nov-16"
 
 ; A simple name for the tileset specified by this file:
 name = "Hexemplio"
diff --git a/data/isophex.tilespec b/data/isophex.tilespec
index cd3e029125..0055fb7dbd 100644
--- a/data/isophex.tilespec
+++ b/data/isophex.tilespec
@@ -2,7 +2,7 @@
 [tilespec]
 
 ; Format and options of this tilespec file:
-options = "+Freeciv-tilespec-3.2-Devel-2022-Jun-21"
+options = "+Freeciv-tilespec-3.3-Devel-2024-Nov-16"
 
 ; A simple name for the tileset specified by this file:
 name = "Isophex"
diff --git a/data/isotrident.tilespec b/data/isotrident.tilespec
index 04fb20c3d7..7e5e371d2e 100644
--- a/data/isotrident.tilespec
+++ b/data/isotrident.tilespec
@@ -2,7 +2,7 @@
 [tilespec]
 
 ; Format and options of this tilespec file:
-options = "+Freeciv-tilespec-3.2-Devel-2022-Jun-21"
+options = "+Freeciv-tilespec-3.3-Devel-2024-Nov-16"
 
 ; A simple name for the tileset specified by this file:
 name = "MacroIsoTrident"
diff --git a/data/toonhex.tilespec b/data/toonhex.tilespec
index 68fc71cfb5..9f8f089771 100644
--- a/data/toonhex.tilespec
+++ b/data/toonhex.tilespec
@@ -2,7 +2,7 @@
 [tilespec]
 
 ; Format and options of this tilespec file:
-options = "+Freeciv-tilespec-3.2-Devel-2022-Jun-21"
+options = "+Freeciv-tilespec-3.3-Devel-2024-Nov-16"
 
 ; A simple name for the tileset specified by this file:
 name = "Toonhex"
diff --git a/data/trident.tilespec b/data/trident.tilespec
index 2df1f7e9c9..9e9ccc0b51 100644
--- a/data/trident.tilespec
+++ b/data/trident.tilespec
@@ -1,7 +1,7 @@
 [tilespec]
 
 ; Format and options of this tilespec file:
-options = "+Freeciv-tilespec-3.2-Devel-2022-Jun-21"
+options = "+Freeciv-tilespec-3.3-Devel-2024-Nov-16"
 
 ; A simple name for the tileset specified by this file:
 name = "Trident"
-- 
2.45.2