From c98676d52e22b0ff40b7d07474c443b7539c0152 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Wed, 4 Dec 2024 21:22:54 +0200
Subject: [PATCH 59/59] alien: Migrate from ui_name_xxx to actions sections

See RM #1139

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/alien/actions.ruleset | 174 ++++++++++---------------------------
 1 file changed, 44 insertions(+), 130 deletions(-)

diff --git a/data/alien/actions.ruleset b/data/alien/actions.ruleset
index 5fb548b029..89599322e6 100644
--- a/data/alien/actions.ruleset
+++ b/data/alien/actions.ruleset
@@ -211,135 +211,6 @@ airlift_max_range = "unlimited"
 ; Will performing this action always consume the actor unit?
 found_city_consuming_always = TRUE
 
-; What each action should be called when showing them to the player.
-; The first %s should be before the mnemonic of the action. A Freeciv client
-; that supports mnemonics will replace it with the in-band signal that marks
-; the following character as a mnemonic in its graphical toolkit.
-; The second %s marks where extra details should be inserted.
-
-; /* TRANS: _Bribe Enemy Unit (3% chance of success). */
-ui_name_bribe_unit = _("%sBribe Enemy Unit%s")
-
-; /* TRANS: _Sabotage City (3% chance of success). */
-ui_name_sabotage_city = _("%sSabotage City%s")
-
-; /* TRANS: Incite a _Revolt (3% chance of success). */
-ui_name_incite_city = _("Incite a %sRevolt%s")
-
-; /* TRANS: Copy Research _Data (3% chance of success). */
-ui_name_steal_tech = _("Copy Research %sData%s")
-
-; /* TRANS: _Investigate City (spends the unit) (100% chance of success). */
-ui_name_investigate_city_spend_unit = _("%sInvestigate City (spends the unit)%s")
-
-; /* TRANS: Establish Trade _Route (100% chance of success). */
-ui_name_establish_trade_route = _("Establish Trade %sRoute%s")
-
-; /* TRANS: Monetize Containers (100% chance of success). */
-ui_name_enter_marketplace = _("Monetize %sContainers%s")
-
-; /* TRANS: Help _build Wonder (100% chance of success). */
-ui_name_help_wonder = _("Help %sbuild Wonder%s")
-
-; /* TRANS: Dis_band recovering production (100% chance of success). */
-ui_name_disband_unit_recover = _("Dis%sband recovering production%s")
-
-; /* TRANS: Dis_band without recovering production (100% chance of success). */
-ui_name_disband_unit = _("Dis%sband without recovering production%s")
-
-; /* TRANS: _Capture Units (100% chance of success). */
-ui_name_capture_units = _("%sCapture Units%s")
-
-; /* TRANS: _Build City (100% chance of success). */
-ui_name_found_city = _("%sBuild City%s")
-
-; /* TRANS: _Add to City (100% chance of success). */
-ui_name_join_city = _("%sAdd to City%s")
-
-; /* TRANS: _Bombard (100% chance of success). */
-ui_name_bombard = _("%sBombard%s")
-
-; /* TRANS: Set _Home City (100% chance of success). */
-ui_name_home_city = _("Set %sHome City%s")
-
-; /* TRANS: _Upgrade Unit (100% chance of success). */
-ui_name_upgrade_unit = _("%sUpgrade Unit%s")
-
-; /* TRANS: Drop _Paratrooper (100% chance of success). */
-ui_name_paradrop_unit_enter = _("Drop %sParatrooper%s")
-
-; /* TRANS: _Paradrop to Contested Landing (100% chance of success). */
-ui_name_paradrop_unit_enter_conquer = _("%sParadrop to Contested Landing%s")
-
-; /* TRANS: _Airlift to City (100% chance of success). */
-ui_name_airlift_unit = _("%sAirlift to City%s")
-
-; /* TRANS: _Attack (100% chance of success). */
-ui_name_attack = _("%sAttack%s")
-
-; /* TRANS: _Explode Missile (100% chance of success). */
-ui_name_suicide_attack = _("%sExplode Missile%s")
-
-; /* TRANS: _Conquer City (100% chance of success). */
-ui_name_conquer_city_shrink = _("%sConquer City%s")
-
-; /* TRANS: _Transform Terrain (3% chance of success). */
-ui_name_transform_terrain = _("%sTransform Terrain%s")
-
-; /* TRANS: Transform by _Cultivating (3% chance of success). */
-ui_name_cultivate = _("Transform by %sCultivating%s")
-
-; /* TRANS: Transform by _Planting (3% chance of success). */
-ui_name_plant = _("Transform by %sPlanting%s")
-
-; /* TRANS: Pilla_ge (100% chance of success). */
-ui_name_pillage = _("Pilla%sge%s")
-
-; /* TRANS: Clean (100% chance of success). */
-ui_name_clean = _("%sClean%s")
-
-; /* TRANS: _Fortify (100% chance of success). */
-ui_name_fortify = _("%sFortify%s")
-
-; /* TRANS: Build _Road (100% chance of success). */
-ui_name_build_road = _("Build %sRoad%s")
-
-; /* TRANS: _Build Base (100% chance of success). */
-ui_name_build_base = _("%sBuild Base%s")
-
-; /* TRANS: Build _Mine (100% chance of success). */
-ui_name_build_mine = _("Build %sMine%s")
-
-; /* TRANS: Build _Irrigation (100% chance of success). */
-ui_name_irrigate = _("Build %sIrrigation%s")
-
-; /* TRANS: _Deboard (100% chance of success). */
-ui_name_transport_deboard = _("%sDeboard%s")
-
-; /* TRANS: _Board (100% chance of success). */
-ui_name_transport_board = _("%sBoard%s")
-
-; /* TRANS: _Unload (100% chance of success). */
-ui_name_transport_unload = _("%sUnload%s")
-
-; /* TRANS: _Disembark (100% chance of success). */
-ui_name_transport_disembark = _("%sDisembark%s")
-
-; /* TRANS: _Disembark from non native (100% chance of success). */
-ui_name_transport_disembark_2 = _("%sDisembark from non native%s")
-
-; /* TRANS: _Embark (100% chance of success). */
-ui_name_transport_embark = _("%sEmbark%s")
-
-; /* TRANS: Enter _Hut (100% chance of success). */
-ui_name_enter_hut = _("Enter %sHut%s")
-
-; /* TRANS: Enter _Hut from non native (100% chance of success). */
-ui_name_enter_hut_2 = _("Enter %sHut from non native%s")
-
-; /* TRANS: Regular _Move (100% chance of success). */
-ui_name_unit_move = _("%sKeep moving%s")
-
 ; Blank ruleset defined user actions.
 ; See the section "Ruleset defined actions" in doc/README.actions
 ; Example: set up "User Action 1"
@@ -384,7 +255,50 @@ quiet_actions = "Transport Disembark 2", "Enter Hut 2", "Unit Move"
 ;
 ; */ <-- avoid gettext warnings
 
-;[action_placeholder]
+
+[action_copy_research_data]
+action  = "Steal Tech"
+ui_name = "Copy Research %sData%s"
+
+[action_incite_a_revolt]
+action  = "Incite City"
+ui_name = "Incite a %sRevolt%s"
+
+[action_monetize_containers]
+action  = "Enter Marketplace"
+ui_name = "Monetize %sContainers%s"
+
+[action_bribe_enemy_unit]
+action  = "Bribe Unit"
+ui_name = "%sBribe Enemy Unit%s"
+
+[action_build_city]
+action  = "Found City"
+ui_name = "%sBuild City%s"
+
+[action_explode_missile]
+action  = "Suicide Attack"
+ui_name = "%sExplode Missile%s"
+
+[action_bombard]
+action  = "Bombard"
+ui_name = "%sBombard%s"
+
+[action_disembark_from_non_native]
+action  = "Transport Disembark 2"
+ui_name = "%sDisembark from non native%s"
+
+[action_enter_hut_from_non_native]
+action  = "Enter Hut 2"
+ui_name = "Enter %sHut from non native%s"
+
+[action_paradrop_to_contested_landing]
+action  = "Paradrop Unit Enter Conquer"
+ui_name = "%sParadrop to Contested Landing%s"
+
+[action_keep_moving]
+action  = "Unit Move"
+ui_name = "%sKeep moving%s"
 
 
 ; /* <-- avoid gettext warnings
-- 
2.45.2